import request from '~/utils/request';
import type { ApiResult, PageResult } from '@/api';
import type { CmsDocsContent, CmsDocsContentParam } from './model';


/**
 * 分页查询文档内容记录表
 */
export async function pageCmsDocsContent(params: CmsDocsContentParam) {
  const res = await request.get<ApiResult<PageResult<CmsDocsContent>>>(
    '/cms/cms-docs-content/page',
    {
      params
    }
  );
  if (res.code === 0) {
    return res.data;
  }
  return Promise.reject(new Error(res.message));
}

/**
 * 查询文档内容记录表列表
 */
export async function listCmsDocsContent(params?: CmsDocsContentParam) {
  const res = await request.get<ApiResult<CmsDocsContent[]>>(
    '/cms/cms-docs-content',
    {
      params
    }
  );
  if (res.code === 0 && res.data) {
    return res.data;
  }
  return Promise.reject(new Error(res.message));
}

/**
 * 添加文档内容记录表
 */
export async function addCmsDocsContent(data: CmsDocsContent) {
  const res = await request.post<ApiResult<unknown>>(
    '/cms/cms-docs-content',
    data
  );
  if (res.code === 0) {
    return res.message;
  }
  return Promise.reject(new Error(res.message));
}

/**
 * 修改文档内容记录表
 */
export async function updateCmsDocsContent(data: CmsDocsContent) {
  const res = await request.put<ApiResult<unknown>>(
    '/cms/cms-docs-content',
    data
  );
  if (res.code === 0) {
    return res.message;
  }
  return Promise.reject(new Error(res.message));
}

/**
 * 删除文档内容记录表
 */
export async function removeCmsDocsContent(id?: number) {
  const res = await request.del<ApiResult<unknown>>(
    '/cms/cms-docs-content/' + id
  );
  if (res.code === 0) {
    return res.message;
  }
  return Promise.reject(new Error(res.message));
}

/**
 * 批量删除文档内容记录表
 */
export async function removeBatchCmsDocsContent(data: (number | undefined)[]) {
  const res = await request.del<ApiResult<unknown>>(
    '/cms/cms-docs-content/batch',
    {
      data
    }
  );
  if (res.code === 0) {
    return res.message;
  }
  return Promise.reject(new Error(res.message));
}

/**
 * 根据id查询文档内容记录表
 */
export async function getCmsDocsContent(id: number) {
  const res = await request.get<ApiResult<CmsDocsContent>>(
    '/cms/cms-docs-content/' + id
  );
  if (res.code === 0 && res.data) {
    return res.data;
  }
  return Promise.reject(new Error(res.message));
}
